# Uebungen Tupel.py

# Tupel sind nicht veränderbar!
b = ('kein', 'Müll')
print( 'indizierter Zugriff lesend:', b[0], b[1] )
print( 'indizierter Zugriff schreibend geht nicht!!!' )
try:
    b[0] = b[1]
except TypeError as e:
    print( "Fehler bei b[0] = b[1] \n"+ str(e) )

### ---------------------------------------------
# Auch Tupel können geschachtelt werden
adressen=( ('Mia','Meier','Hannover'), ('Jan','Mueller','Hamburg') )
print( adressen[0] ) # erstes Element der Gesamtliste
#-> ['Mia', 'Meier', 'Hannover']
# lesender Zugriff auch in der Tiefe:
print( adressen[1][1] )
try:
    adressen[1][1]="Müller"    # kein schreibender Zugriff!!!
except TypeError as e:
    print( 'Fehler bei adressen[1][1]="Müller "\n'+ str(e) )

# unpacking:
vorname,nachname,ort=('Mia','Meier','Hannover')
print( 'entpackt: ', vorname, nachname, ort)

### ---------------------------------------------
# Bruch mit Tupeln
b1 = (3, 4)
b2 = (4, 5)
bs = b1 + b2
print( b1, '+', b2, '=', bs, 'ist nicht das, was man will.' )

def multipliziere(a, b):
    return a[0]*b[0], a[1]*b[1]

# Ergebnis automatisch wieder ein Tupel
ergebnis=multipliziere(b1,b2)
print( b1, '*', b2, '=', ergebnis, type(ergebnis) )

def addiere(a, b):
    az, an = a
    bz, bn = b
    return az*bn+bz*an, an*bn
print( b1, '+', b2, '=', addiere(b1, b2) )
