# Uebungen Listen.py

### ACHTUNG! Listen sind veränderbare Objekte,
### Wertzuweisungen zu einer neuen Variablen
### erzeugen kein(!) neues Objekt!
z=[1,2,3,4,5,6]
neu=z
z.append('sieben')
print( neu )
#-> [1, 2, 3, 4, 5, 6, 'sieben']
### aber:
zz=[1,2,3,4,5,6]
ganz_neu=[]+zz        # echte Kopie!
z.append('sieben')
print( ganz_neu )
#-> [1, 2, 3, 4, 5, 6]

### ---------------------------------------------
### Zugriffe und slices
meineListe = [34,988,236457,746]
print( meineListe[1] )
#-> 988
print( len(meineListe) )
#-> 4
##print( meineListe[4] ) geht nicht, Indizes sind 0 basierend
print( meineListe[1:3] )
#-> [988, 236457]
meineListe[3:3]=[35] # verändert die Liste dauerhaft!
print( meineListe )
#-> [34, 988, 236457, 35, 746]
meineListe[1:3]=[0,0,0,0,0]
#-> [34, 0, 0, 0, 0, 0, 35, 746]

### ---------------------------------------------
### Adressen mit Listen
adressen=[ ['Mia','Meier','Hannover'], ['Jan','Mueller','Hamburg'] ]
print( adressen[0] ) # erstes Element der Gesamtliste
#-> ['Mia', 'Meier', 'Hannover']
adressen[1][1]="Müller"    # Listen sind veränderbar
print( adressen )
#-> [['Mia', 'Meier', 'Hannover'], ['Jan', 'Müller', 'Hamburg']]

### ---------------------------------------------
### Sortieren durch Einfügen
def sortiere(liste):
    sortierte_Liste = []
    for element in liste:
        fuege_ein(element, sortierte_Liste) # call-by-reference!
    return sortierte_Liste

def fuege_ein(element, liste):
    for index in range(len(liste)):
        if liste[index]>element:
            liste.insert(index,element)
            # Die Liste ist durch insert nicht nur lokal verändert!
            return
    liste.append(element)
    return

##print( sortiere([34,988,236457,35,746,256,82,3,23423,23,452,3,1]) )
##[34]
##[34,988]
##[34,988,236457]
##[34,35,988,236457]

